import 'package:logger/logger.dart';
import 'package:logger/logger.dart' as log_show;

class logger {
  static void info(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    _logger.i(formattedText);
  }

  static void i(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    _loggerSm.i(formattedText);
  }

  static void w(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    _loggerSm.w(formattedText);
  }

  static void e(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    _loggerSm.e(formattedText);
  }

  static void s(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    loggerSuccess.i(formattedText);
  }

  static void error(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);
    _logger.e(formattedText);
  }

  static void warn(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);
    _logger.w(formattedText);
  }

  static void debug(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);

    _logger.d(formattedText);
  }

  static void success(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    var formattedText =
        getString(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);
    loggerSuccess.i(formattedText);
  }

  static dynamic getString(
      [dynamic arg1,
      dynamic arg2,
      dynamic arg3,
      dynamic arg4,
      dynamic arg5,
      dynamic arg6,
      dynamic arg7,
      dynamic arg8,
      dynamic arg9,
      dynamic arg10]) {
    List<dynamic> args = [
      arg1,
      arg2,
      arg3,
      arg4,
      arg5,
      arg6,
      arg7,
      arg8,
      arg9,
      arg10
    ];
    // 过滤掉 null
    args.removeWhere((element) => element == null);
    if (args.isEmpty) return "";
    if (args.length == 1) return args[0];

    String formattedText = "";
    for (var arg in args) {
      int index = args.indexOf(arg);
      if (arg == null) {
        break;
      }
      // 如果是最后一个不加 \n
      if (index == args.length - 1) {
        formattedText += "$arg";
      } else {
        formattedText += "$arg\n";
      }
    }

    return formattedText;
  }
}

var _logger = log_show.Logger(
  printer: PrettyPrinter(
    stackTraceBeginIndex: 1,
    methodCount: 3,
    dateTimeFormat: DateTimeFormat.dateAndTime,
  ), // SimplePrinter PrefixPrinter LogfmtPrinter HybridPrinter PrettyPrinter
);
var _loggerSm = log_show.Logger(
  printer: PrettyPrinter(
    stackTraceBeginIndex: 0,
    methodCount: 0,
    // dateTimeFormat: DateTimeFormat.dateAndTime,
  ), // SimplePrinter PrefixPrinter LogfmtPrinter HybridPrinter PrettyPrinter
);

var loggerSuccess = log_show.Logger(
  printer: PrettyPrinter(
    stackTraceBeginIndex: 1,
    methodCount: 3,
    dateTimeFormat: DateTimeFormat.dateAndTime,
    levelColors: {
      Level.trace: AnsiColor.fg(AnsiColor.grey(0.5)),
      Level.debug: const AnsiColor.none(),
      Level.info: const AnsiColor.fg(41),
      Level.warning: const AnsiColor.fg(208),
      Level.error: const AnsiColor.fg(196),
      Level.fatal: const AnsiColor.fg(199),
    },
  ), // SimplePrinter PrefixPrinter LogfmtPrinter HybridPrinter PrettyPrinter
);
